/******************************************************************************
 *
 * Project:  OpenCPN
 * Purpose:  GE2KAP Plugin Freinds
 * Author:   Paul Higgins
 *
 ***************************************************************************
 *   Copyright (C) 2010 by Paul Higgins                                    *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Street, Fifth Floor, Boston, MA 02110-1301,  USA.             *
 ***************************************************************************
 */

#ifndef _GE2KAP_H_
#define _GE2KAP_H_


#include "wx/wxprec.h"

#ifndef  WX_PRECOMP
  #include "wx/wx.h"
#endif //precompiled headers

#include <wx/treectrl.h>
#include <wx/fileconf.h>
#include <wx/notebook.h>
#include <wx/glcanvas.h>


#define ID_OK                       10001

#ifndef PI
#define PI        3.1415926535897931160E0      /* pi */
#endif

class wxFileConfig;
class ge2kap_pi;



//----------------------------------------------------------------------------------------------------------
//    GE2KAP Selector/Control Dialog Specification
//----------------------------------------------------------------------------------------------------------
class GE2KAPUIDialog: public wxDialog
{
      DECLARE_CLASS( GE2KAPUIDialog )
                  DECLARE_EVENT_TABLE()
      public:

           GE2KAPUIDialog( );

            ~GE2KAPUIDialog( );
            void Init();

            /*
            double m_lat_ul, m_lon_ul;  // Upper left  lat and lon
            double m_lat_ll, m_lon_ll;  // Lower left  lat and lon
            double m_lat_lr, m_lon_lr;  // Lower right  lat and lon
            double m_lat_ur, m_lon_ur;  // Upper right lat and lon  
            double skew, rotation;       // Scew and Rotation   
            wxRect   rect; 
            int      pix_width;
            int      pix_height;
            */
            PlugIn_ViewPort my_vp;
            
            char rxText[512];
            int count;
            char* pch;
            int pch_offset;  
            int dataln;              

            bool Create(  wxWindow *parent, ge2kap_pi *ppi, wxWindowID id = wxID_ANY,
                         const wxString& caption = _("GE2KAP Display Control"), const wxString initial_ge2kap_dir = wxT(""),
                         const wxPoint& pos = wxDefaultPosition,
                         const wxSize& size = wxDefaultSize,
                         long style = wxCAPTION|wxRESIZE_BORDER|wxSYSTEM_MENU );
           WXLRESULT  MSWDefWindowProc(WXUINT message, WXWPARAM wParam, WXLPARAM lParam); 
           void CreateControls();   
           // void SetViewPort(PlugIn_ViewPort vp);  
           void SetViewPort(double ul_lat, double ul_lon, double lr_lat, double lr_lon, double ll_lat, double ll_lon, double ur_lat, double ur_lon);               

      private:
            void OnClose(wxCloseEvent& event);
            void OnIdOKClick( wxCommandEvent& event );
            void OnMove( wxMoveEvent& event );
            void OnSize( wxSizeEvent& event );
            void OnChooseDirClick( wxCommandEvent& event );
            void On_Text_Changed( wxCommandEvent& event );

            //    Data
            wxWindow          *pParent;
            ge2kap_pi           *pPlugIn;

            wxFont            *m_dFont;

            int               m_n_files;

            wxTextCtrl        *m_pitemCurrentge2kapDirectoryCtrl;
            wxString          m_currentge2kapDir;
            wxString          m_gpx_filename;

};

///////////////////////////////////////////////////////////////////////////////
/// Class ge2kapPrefsDialog
///////////////////////////////////////////////////////////////////////////////
class ge2kapPrefsDialog : public wxDialog 
{
	private:
	
	protected:
		wxStdDialogButtonSizer* m_sdbSizer1;
		wxButton* m_sdbSizer1OK;
		wxButton* m_sdbSizer1Cancel;
	
	public:

      wxCheckBox*  m_cbShowIcon;
		
		ge2kapPrefsDialog( wxWindow* parent, wxWindowID id = wxID_ANY, const wxString& title = _("ge2kap Preferences"), const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = wxCAPTION|wxDEFAULT_DIALOG_STYLE ); 
		~ge2kapPrefsDialog();
	
};


#endif